Bug 910137 - Review Request: nodejs-node-stringprep - ICU StringPrep profiles for Node.js
Summary: Review Request: nodejs-node-stringprep - ICU StringPrep profiles for Node.js
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Tom Hughes
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 910114
Blocks: 910147 910154 911022
TreeView+ depends on / blocked
 
Reported: 2013-02-11 21:32 UTC by Jamie Nguyen
Modified: 2013-04-07 00:34 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-03-19 14:16:27 UTC
tom: fedora-review+
pbabinca: fedora-cvs+


Attachments (Terms of Use)

Description Jamie Nguyen 2013-02-11 21:32:51 UTC
Spec URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/nodejs-node-stringprep.spec
SRPM URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/SRPMS/nodejs-node-stringprep-0.1.5-1.fc18.src.rpm
Fedora Account System Username: jamielinux

Description:
This module exposes predefined Unicode normalization functions that are
required by many protocols. This is just a binding to ICU, which is said
to be fast.

Comment 2 Tom Hughes 2013-03-17 14:42:59 UTC
Package Review
==============

Key:
[x] = Pass
[!] = Fail
[-] = Not applicable
[?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Package complies to the Packaging Guidelines

Node guidelines say that where the compiled module is the main entry
point it should be called %{nodejs_sitelib}/<module name>/<module_name>.node

- Requires correct, justified where necessary.

The explicit requires on v8 should not be needed any more.

- Useful -debuginfo package or justification otherwise.

There is no debuginfo package for some reason. Suspect it 

- Patches link to upstream bugs/comments/lists or are otherwise justified.

The second patch can be offered upstream - although older versions
of node work without an explicit NODE_MODULE they still accept it 
as I understand things.

- %check is present and all tests pass.

Tests spit out a string of warnings:

(node) warning: Recursive process.nextTick detected. This will break in the next version of node. Please use setImmediate for recursive deferral.

and then die:

RangeError: Maximum call stack size exceeded

- Rpmlint is run on all installed packages.

nodejs-node-stringprep.x86_64: E: non-standard-executable-perm /usr/lib/node_modules/node-stringprep/build/node_stringprep.node 0775L

- General issues.

The comment about not be able to make index.node work is not
relevant as the packaging guidelines say to use module_name.node
in this case anyway.


===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[!]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "Unknown or generated". 1 files have unknown license. Detailed output of
     licensecheck in /home/tom/910137-nodejs-node-stringprep/licensecheck.txt
[x]: Package consistently uses macro is (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[!]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[!]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
     Note: Documentation size is 10240 bytes in 2 files.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[!]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[!]: Patches link to upstream bugs/comments/lists or are otherwise justified.
[-]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[!]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: nodejs-node-stringprep-0.1.5-2.fc20.x86_64.rpm
nodejs-node-stringprep.x86_64: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-node-stringprep.x86_64: W: dangling-symlink /usr/lib/node_modules/node-stringprep/node_modules/bindings /usr/lib/node_modules/bindings
nodejs-node-stringprep.x86_64: E: non-standard-executable-perm /usr/lib/node_modules/node-stringprep/build/node_stringprep.node 0775L
1 packages and 0 specfiles checked; 1 errors, 2 warnings.




Rpmlint (installed packages)
----------------------------
# rpmlint nodejs-node-stringprep
nodejs-node-stringprep.x86_64: W: spelling-error Summary(en_US) js -> dis, ks, j
nodejs-node-stringprep.x86_64: W: dangling-symlink /usr/lib/node_modules/node-stringprep/node_modules/bindings /usr/lib/node_modules/bindings
nodejs-node-stringprep.x86_64: E: non-standard-executable-perm /usr/lib/node_modules/node-stringprep/build/node_stringprep.node 0775L
1 packages and 0 specfiles checked; 1 errors, 2 warnings.
# echo 'rpmlint-done:'



Requires
--------
nodejs-node-stringprep (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libicudata.so.50()(64bit)
    libicui18n.so.50()(64bit)
    libicuuc.so.50()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    nodejs(abi)
    nodejs(engine)
    nodejs(v8-abi)
    npm(bindings)
    rtld(GNU_HASH)
    v8



Provides
--------
nodejs-node-stringprep:
    node_stringprep.node()(64bit)
    nodejs-node-stringprep
    nodejs-node-stringprep(x86-64)
    npm(node-stringprep)



MD5-sum check
-------------
http://registry.npmjs.org/node-stringprep/-/node-stringprep-0.1.5.tgz :
  CHECKSUM(SHA256) this package     : 713c6352ca62d5202fa6eb74f67802d871e8b88eccf569600a3d2b7427b51ed1
  CHECKSUM(SHA256) upstream package : 713c6352ca62d5202fa6eb74f67802d871e8b88eccf569600a3d2b7427b51ed1


Generated by fedora-review 0.4.0 (660ce56) last change: 2013-01-29
Buildroot used: compton-rawhide-x86_64
Command line :/usr/bin/fedora-review -m compton-rawhide-x86_64 -b 910137

Comment 3 Jamie Nguyen 2013-03-17 15:38:06 UTC
Spec URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/nodejs-node-stringprep.spec
SRPM URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/SRPMS/nodejs-node-stringprep-0.1.5-3.fc18.src.rpm


> Node guidelines say that where the compiled module is the main entry
> point it should be called %{nodejs_sitelib}/<module name>/<module_name>.node

Fixed.


> The explicit requires on v8 should not be needed any more.

Removed.


> There is no debuginfo package for some reason.

It's present now.


> The second patch can be offered upstream - although older versions
> of node work without an explicit NODE_MODULE they still accept it 
> as I understand things.

Pull request sent.


> Tests spit out a string of warnings:

Fixed.


> nodejs-node-stringprep.x86_64: E: non-standard-executable-perm /usr/lib/node_modules/node-stringprep/build/node_stringprep.node 0775L

Fixed.


> The comment about not be able to make index.node work is not
> relevant as the packaging guidelines say to use module_name.node
> in this case anyway.

Removed.

Comment 4 Tom Hughes 2013-03-17 15:56:37 UTC
I'm confused the way the .node file is being handled...

You're installing it in build, linking to that from the top level (where the guidelines say it should and where the patched package.json expects it) and then using sed to edit package.json again to point at build?

Why not just install it at the top level and leave package.json alone?

Comment 5 Jamie Nguyen 2013-03-17 16:25:24 UTC
I'm also confused as to what exactly I was trying to achieve. I didn't notice I was patching and sed-ing package.json at the same time...

I've removed the bindings related things as that isn't necessary at all, and I'm now doing something a bit more sensible with regards to package.json.

Spec URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/nodejs-node-stringprep.spec
SRPM URL: http://jamielinux.fedorapeople.org/nodejs-buddycloud-http-api/SRPMS/nodejs-node-stringprep-0.1.5-4.fc18.src.rpm

Comment 6 Tom Hughes 2013-03-17 16:32:47 UTC
That looks much better. Package approved.

Comment 7 Jamie Nguyen 2013-03-17 16:40:11 UTC
New Package SCM Request
=======================
Package Name: nodejs-node-stringprep
Short Description: ICU StringPrep profiles for Node.js
Owners: jamielinux
Branches: f18 f19 el6
InitialCC:

Comment 8 Pavol Babinčák 2013-03-18 08:46:47 UTC
Git done (by process-git-requests).

Comment 9 Fedora Update System 2013-03-18 20:12:11 UTC
nodejs-node-stringprep-0.1.5-4.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/nodejs-node-stringprep-0.1.5-4.fc18

Comment 10 Fedora Update System 2013-04-07 00:34:48 UTC
nodejs-node-stringprep-0.1.5-4.fc18 has been pushed to the Fedora 18 stable repository.


Note You need to log in before you can comment on or make changes to this bug.